precision highp float;
precision highp int;
uniform mat4 uMVPMatrix; //总变换矩阵
attribute vec3 aPosition;  //顶点位置
attribute vec2 aTexCoor;    //顶点纹理坐标
varying vec2 vTextureCoord;  //用于传递给片元着色器的变量
uniform vec3 uTransformArray;
uniform float uNewCenterX;
uniform float uNewCenterY;
uniform float uDivideCount;
uniform vec4 tuoyuanRela;
uniform float widthHeightRate;//宽高比
void main()     
{       
	float pi = 3.1415926; 
	//中心点的X坐标和Y坐标
	float centerX=tuoyuanRela[0];
	float centerY=tuoyuanRela[1];//转化为与X轴同单位.
	float tuoyuanA = tuoyuanRela[2];
	float tuoyuanB = tuoyuanRela[3];
	//获取当前点的X坐标和Y坐标
	float currX = aPosition.x;
	float currY = aPosition.y;//转化为与X轴同单位.
	//计算X和Y的偏移量
	float spanX = currX - centerX;
	float spanY = currY - centerY;
	//计算极径
	float currRadius = sqrt(spanX * spanX + spanY * spanY);
	//计算当前点的极角
	float currRadians;//用弧度表示
	
	float endX ;
    float endY ;
	if(spanX != 0.0)
	{
		currRadians = atan(spanY , spanX);
	}
	else
	{
		currRadians = spanY > 0.0 ? pi/2.0 : 3.0*pi/2.0; 
	}
	
    if (currX==centerX) {//x=pixcelObjTwo.columnIndex,圆(x-c)2/a2+(y-d)2b2=1
        float step = currY>centerY?1.0:-1.0;
        endX = currX;
   //     endY = step*(sqrt(tuoyuanB*tuoyuanB-tuoyuanB*tuoyuanB*(currX-centerX)*(currX-centerX))/(tuoyuanA*tuoyuanA))+centerY;
        endY = step*tuoyuanB+centerY;
    } else {
	    float a,b;
	    a = (currY-centerY)/(currX-centerX);
	    b = currY-a*currX;
        float a2= a*a*tuoyuanA*tuoyuanA+tuoyuanB*tuoyuanB;
        float b2 = 2.0*tuoyuanA*tuoyuanA*a*(b-centerY)-2.0*tuoyuanB*tuoyuanB*centerX;
        float c2 = tuoyuanB*tuoyuanB*centerX*centerX-tuoyuanA*tuoyuanA*tuoyuanB*tuoyuanB+tuoyuanA*tuoyuanA*(b-centerY)*(b-centerY);
        float deta = b2*b2-4.0*a2*c2;
        if (deta<0.0) {//error
            
        }
        float xx1=(-b2-sqrt(deta))/(2.0*a2);
        float xx2=(-b2+sqrt(deta))/(2.0*a2);
        float smallerX = xx1>=xx2?xx2:xx1;
        float largerX = xx1>=xx2?xx1:xx2;
        if (currX>centerX) {
            endX = largerX;
        } else {
            endX = smallerX;
        }
        endY = a*endX+b;
        
    }
	
	 //要从原来的点求变换后的点,与worker相反.
	//endX = centerX+tuoyuanA*cos(currRadians);//巨坑,不精确.
	//endY = centerY+tuoyuanB*sin(currRadians);
	
	float segment1 = sqrt((currX - endX)*(currX - endX)+(currY - endY)*(currY - endY));
//	float segment2 = sqrt((uNewCenterX - endX)*(uNewCenterX - endX)+(uNewCenterY - endY)*(uNewCenterY - endY));
	float segment2 = sqrt((centerX - endX)*(centerX - endX)+(centerY - endY)*(centerY - endY));
    float rate = segment1/segment2;
    //从原位置找新位置.
    
	float resultX =-(endX-uNewCenterX)*rate+endX;
    float resultY = -(endY-uNewCenterY)*rate+endY;
    if (currX==centerX) {
    	//resultX = currX;
    	//resultY = currY-uNewCenterX;
    	//resultY = aPosition.y;
    }
	//resultY=是刻度与X相同的,要转化为GL中对应的位置.
	//resultX = aPosition.x;
	
	//进行扭曲
	//float resultRadians = currRadians;
	//float divide = pi * 2.0/uDivideCount;
	//int whichArea = int(resultRadians/divide);
	// vec3 xTransformArray = vec3(uTransformArray[6 * whichArea+0],uTransformArray[6*whichArea+1],uTransformArray[6*whichArea+2]);
	// vec3 yTransformArray = vec3(uTransformArray[6 * whichArea+3],uTransformArray[6*whichArea+4],uTransformArray[6*whichArea+5]);
	// //计算结果点
	// float resultX = xTransformArray[0]*aPosition.x+xTransformArray[1]*aPosition.y+xTransformArray[2]*aPosition.z;
	// float resultY = yTransformArray[0]*aPosition.x+yTransformArray[1]*aPosition.y+yTransformArray[2]*aPosition.z;
	
	float result = (currX-centerX)*(currX-centerX)/(tuoyuanA*tuoyuanA)+(currY-centerY)*(currY-centerY)/(tuoyuanB*tuoyuanB);
        if (result>=1.0-0.0000000000001 && result<=1.0+0.0000000000001) {//边缘点.
   //  gl_Position = uMVPMatrix * vec4(aPosition.x,aPosition.y,0.0,1); //根据总变换矩阵计算此次绘制此顶点位置
        } else {
	//构造结果点
 //   gl_Position = uMVPMatrix * vec4(resultX,resultY,0.0,1); //根据总变换矩阵计算此次绘制此顶点位置
        }
	
//	 gl_Position = uMVPMatrix * vec4(aPosition.x,aPosition.y,0.0,1); //根据总变换矩阵计算此次绘制此顶点位置
	gl_Position = uMVPMatrix * vec4(resultX,resultY,0.0,1); //根据总变换矩阵计算此次绘制此顶点位置
	
	
	
    vTextureCoord = aTexCoor;//将接收的纹理坐标传递给片元着色器
    
    
      
}                       